Lorene::Star_bin Class Reference
Stars and black holes

Class for stars in binary system. More...

`#include <star.h>`

Inheritance diagram for Lorene::Star_bin:

## Public Member Functions

| Star_bin (Map &mp_i, int nzet_i, const Eos &eos_i, bool irrot, bool conf_flat)
| Standard constructor.
| Star_bin (const Star_bin &)
| Copy constructor.
| Star_bin (Map &mp_i, const Eos &eos_i, FILE *fich)
| Constructor from a file (see `sauve(FILE* )`).
virtual | ~Star_bin ()
| Destructor.
void | operator= (const Star_bin &)
| Assignment to another `Star_bin`.
Scalar & | set_pot_centri ()
| Read/write the centrifugal potential.
Scalar & | set_logn_comp ()
| Read/write of the logarithm of the lapse generated principally by the companion.
void | set_logn_auto (const Scalar &logn_auto_new)
| Assignment of a new logn_auto.
void | set_lnq_auto (const Scalar &lnq_auto_new)
| Assignment of a new lnq_auto.
Vector & | set_beta_auto ()
| Read/write of .
Vector & | set_beta ()
| Read/write of .
void | set_conf_flat (bool confflat)
| Write if conformally flat.
bool | is_irrotational () const
| Returns `true` for an irrotational motion, `false` for a corotating one.
const Scalar & | get_psi0 () const
| Returns the non-translational part of the velocity potential.
const Vector & | get_d_psi () const
| Returns the covariant derivative of the velocity potential (Spherical components with respect to the mapping of the star).
const Vector & | get_wit_w () const
| Returns the spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.
const Scalar & | get_loggam () const
| Returns the logarithm of the Lorentz factor between the fluid and the co-orbiting observer.
const Vector & | get_bsn () const
| Returns the shift vector, divided by N, of the rotating coordinates, .
const Scalar & | get_pot_centri () const
| Returns the centrifugal potential.
const Scalar & | get_logn_auto () const
| Returns the part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the star.
const Scalar & | get_logn_comp () const
| Returns the part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the companion star.
const Vector & | get_beta_auto () const
| Returns the part of the shift vector generated principally by the star.
const Vector & | get_beta_comp () const
| Returns the part of the shift vector generated principally by the star.
const Scalar & | get_lnq_auto () const
| Returns the part of the vector field generated principally by the star.
const Scalar & | get_lnq_comp () const
| Returns the part of the vector field generated principally by the companion star.
const Vector & | get_dcov_logn () const
| Returns the covariant derivative of .
const Vector & | get_dcon_logn () const
| Returns the contravariant derivative of .
const Vector & | get_dcov_phi () const
| Returns the covariant derivative of (logarithm of the conformal factor).
const Vector & | get_dcon_phi () const
| Returns the contravariant derivative of (logarithm of the conformal factor).
const Scalar & | get_psi4 () const
| Return the conformal factor .
const Metric & | get_flat () const
| Return the flat metric defined on the mapping (Spherical components with respect to the mapping of the star).
const Metric & | get_gtilde () const
| Return the conformal 3-metric .
const Sym_tensor & | get_hij () const
| Return the total deviation of the inverse conformal metric from the inverse flat metric.
const Sym_tensor & | get_hij_auto () const
| Return the deviation of the inverse conformal metric from the inverse flat metric principally generated by the star.
const Sym_tensor & | get_hij_comp () const
| Return the deviation of the inverse conformal metric from the inverse flat metric generated principally by the companion star.
const Sym_tensor & | get_tkij_auto () const
| Returns the part of the extrinsic curvature tensor generated by `beta_auto`.
const Sym_tensor & | get_tkij_comp () const
| Returns the part of the extrinsic curvature tensor generated by `beta_comp`.
const Scalar & | get_kcar_auto () const
| Returns the part of generated by `beta_auto`.
const Scalar & | get_kcar_comp () const
| Returns the part of generated by `beta_comp`.
const Scalar | get_decouple () const
| Returns the function used to construct `beta_auto` from `beta`.
bool | is_conf_flat () const
virtual void | sauve (FILE *) const
| Save in a file.
virtual double | mass_b () const
| Baryon mass.
virtual double | mass_g () const
| Gravitational mass.
virtual double | xa_barycenter () const
| Absolute coordinate X of the barycenter of the baryon density,.
virtual void | hydro_euler ()
| Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame, as well as `wit_w` and `loggam`.
void | update_metric (const Star_bin &comp, double omega)
| Computes metric coefficients from known potentials, when the companion is another star.
void | update_metric (const Star_bin &comp, const Star_bin &star_prev, double relax, double omega)
| Same as `update_metric`(const Star_bin& ) but with relaxation.
void | update_metric_der_comp (const Star_bin &comp, double omega)
| Computes the derivative of metric functions related to the companion star.
void | kinematics (double omega, double x_axe)
| Computes the quantities `bsn` and `pot_centri`.
void | fait_d_psi ()
| Computes the gradient of the total velocity potential .
void | extrinsic_curvature (double omega)
| Computes `tkij_auto` and `akcar_auto` from `beta_auto`, `nn` and `Q`.
void | equilibrium (double ent_c, int mermax, int mermax_potvit, int mermax_poisson, double relax_poisson, double relax_potvit, double thres_adapt, Tbl &diff, double om)
| Computes an equilibrium configuration.
double | velocity_potential (int mermax, double precis, double relax)
| Computes the non-translational part of the velocity scalar potential by solving the continuity equation.
void | relaxation (const Star_bin &star_prev, double relax_ent, double relax_met, int mer, int fmer_met)
| Performs a relaxation on `ent`, `logn_auto`, `lnq_auto`, `beta_auto` and `hij_auto`.
void | test_K_Hi () const
| Test if the gauge conditions we impose are well satisfied.
void | helical (double omega) const
| Test of the helical symmetry.
Map & | set_mp ()
| Read/write of the mapping.
void | set_enthalpy (const Scalar &)
| Assignment of the enthalpy field.
void | equation_of_state ()
| Computes the proper baryon and energy density, as well as pressure from the enthalpy.
virtual void | equilibrium_spher (double ent_c, double precis=1.e-14, const Tbl *pent_limit=0x0)
| Computes a spherical static configuration.
const Map & | get_mp () const
| Returns the mapping.
int | get_nzet () const
| Returns the number of domains occupied by the star.
const Eos & | get_eos () const
| Returns the equation of state.
const Scalar & | get_ent () const
| Returns the enthalpy field.
const Scalar & | get_nbar () const
| Returns the proper baryon density.
const Scalar & | get_ener () const
| Returns the proper total energy density.
const Scalar & | get_press () const
| Returns the fluid pressure.
const Scalar & | get_ener_euler () const
| Returns the total energy density with respect to the Eulerian observer.
const Scalar & | get_s_euler () const
| Returns the trace of the stress tensor in the Eulerian frame.
const Scalar & | get_gam_euler () const
| Returns the Lorentz factor between the fluid and Eulerian observers.
const Vector & | get_u_euler () const
| Returns the fluid 3-velocity with respect to the Eulerian observer.
const Tensor & | get_stress_euler () const
| Returns the spatial part of the stress-energy tensor with respect to the Eulerian observer.
const Scalar & | get_logn () const
| Returns the logarithm of the lapse N.
const Scalar & | get_nn () const
| Returns the lapse function N.
const Vector & | get_beta () const
| Returns the shift vector .
const Scalar & | get_lnq () const
const Metric & | get_gamma () const
| Returns the 3-metric .
double | ray_eq () const
| Coordinate radius at , [r_unit].
double | ray_eq_pis2 () const
| Coordinate radius at , [r_unit].
double | ray_eq_pi () const
| Coordinate radius at , [r_unit].
double | ray_eq_3pis2 () const
| Coordinate radius at , [r_unit].
double | ray_pole () const
| Coordinate radius at [r_unit].
virtual const Itbl & | l_surf () const
| Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
const Tbl & | xi_surf () const
| Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

## Protected Member Functions

virtual void | del_deriv () const
| Deletes all the derived quantities.
virtual void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
virtual void | del_hydro_euler ()
| Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.
virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator <<).

## Protected Attributes

bool | irrotational
| `true` for an irrotational star, `false` for a corotating one
Scalar | psi0
| Scalar potential of the non-translational part of fluid 4-velocity (in the irrotational case).
Vector | d_psi
| Gradient of (in the irrotational case) (Spherical components with respect to the mapping of the star).
Vector | wit_w
| Spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.
Scalar | loggam
| Logarithm of the Lorentz factor between the fluid and the co-orbiting observer.
Vector | bsn
| 3-vector shift, divided by N, of the rotating coordinates, .
Scalar | pot_centri
| Centrifugal potential.
Scalar | logn_auto
| Part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the star.
Scalar | logn_comp
| Part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the companion star.
Vector | dcov_logn
| Covariant derivative of the total logarithm of the lapse.
Vector | dcon_logn
| Contravariant derivative of the total logarithm of the lapse.
Scalar | lnq_auto
| Scalar field generated principally by the star.
Scalar | lnq_comp
| Scalar field generated principally by the companion star.
Scalar | psi4
| Conformal factor .
Vector | dcov_phi
| Covariant derivative of the logarithm of the conformal factor.
Vector | dcon_phi
| Contravariant derivative of the logarithm of the conformal factor.
Metric_flat | flat
| Flat metric defined on the mapping (Spherical components with respect to the mapping of the star) .
Metric | gtilde
| Conformal metric .
Vector | beta_auto
| Part of the shift vector generated principally by the star (Spherical components with respect to the mapping of the star).
Vector | beta_comp
| Part of the shift vector generated principally by the star (Spherical components with respect to the mapping of the star).
Sym_tensor | hij
| Total deviation of the inverse conformal metric from the inverse flat metric.
Sym_tensor | hij_auto
| Deviation of the inverse conformal metric from the inverse flat metric generated principally by the star.
Sym_tensor | hij_comp
| Deviation of the inverse conformal metric from the inverse flat metric generated principally by the companion star.
Sym_tensor | tkij_auto
| Part of the extrinsic curvature tensor generated by `beta_auto`.
Sym_tensor | tkij_comp
| Part of the extrinsic curvature tensor generated by `beta_comp`.
Scalar | kcar_auto
| Part of the scalar generated by `beta_auto`, i.e.
Scalar | kcar_comp
| Part of the scalar generated by `beta_auto` and `beta_comp`, i.e.
Scalar | ssjm1_logn
| Effective source at the previous step for the resolution of the Poisson equation for `logn_auto`.
Scalar | ssjm1_lnq
| Effective source at the previous step for the resolution of the Poisson equation for `lnq_auto`.
Scalar | ssjm1_khi
| Effective source at the previous step for the resolution of the Poisson equation for `khi`.
Vector | ssjm1_wbeta
Scalar | ssjm1_h11
| Effective source at the previous step for the resolution of the Poisson equation for `h00_auto`.
Scalar | ssjm1_h21
| Effective source at the previous step for the resolution of the Poisson equation for `h10_auto`.
Scalar | ssjm1_h31
| Effective source at the previous step for the resolution of the Poisson equation for `h20_auto`.
Scalar | ssjm1_h22
| Effective source at the previous step for the resolution of the Poisson equation for `h11_auto`.
Scalar | ssjm1_h32
| Effective source at the previous step for the resolution of the Poisson equation for `h21_auto`.
Scalar | ssjm1_h33
| Effective source at the previous step for the resolution of the Poisson equation for `h22_auto`.
Scalar | decouple
| Function used to construct the part generated by the star from the total .
bool | conf_flat
| `true` if the 3-metric is conformally flat, `false` for a more general metric.
double * | p_xa_barycenter
| Absolute coordinate X of the barycenter of the baryon density.
Map & | mp
| Mapping associated with the star.
int | nzet
| Number of domains of `*mp` occupied by the star.
const Eos & | eos
| Equation of state of the stellar matter.
Scalar | ent
| Log-enthalpy.
Scalar | nbar
| Baryon density in the fluid frame.
Scalar | ener
| Total energy density in the fluid frame.
Scalar | press
| Fluid pressure.
Scalar | ener_euler
| Total energy density in the Eulerian frame.
Scalar | s_euler
| Trace of the stress scalar in the Eulerian frame.
Scalar | gam_euler
| Lorentz factor between the fluid and Eulerian observers.
Vector | u_euler
| Fluid 3-velocity with respect to the Eulerian observer.
Sym_tensor | stress_euler
| Spatial part of the stress-energy tensor with respect to the Eulerian observer.
Scalar | logn
| Logarithm of the lapse N .
Scalar | nn
| Lapse function N .
Vector | beta
| Shift vector.
Scalar | lnq
Metric | gamma
| 3-metric
double * | p_ray_eq
| Coordinate radius at , .
double * | p_ray_eq_pis2
| Coordinate radius at , .
double * | p_ray_eq_pi
| Coordinate radius at , .
double * | p_ray_eq_3pis2
| Coordinate radius at , .
double * | p_ray_pole
| Coordinate radius at .
Itbl * | p_l_surf
| Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
Tbl * | p_xi_surf
| Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .
double * | p_mass_b
| Baryon mass.
double * | p_mass_g
| Gravitational mass.

## Friends

class | Binary

## Detailed Description

Class for stars in binary system.

*** UNDER DEEVELOPMENT ***()

A `Star_bin` can be construted in two states, represented by the `bool` member `irrotational:` (i) irrotational (i.e. the fluid motion is irrotational) or (ii) rigidly corotating with respect to the orbital motion (synchronized binary).

Version
  #$Id: star.h,v 1.32 2014/10/13 08:52:36 j_novak Exp $#

Definition at line 483 of file star.h.

## Constructor & Destructor Documentation

## Star_bin() [1/3]

Lorene::Star_bin::Star_bin | ( | Map & | mp_i,
|  | int | nzet_i,
|  | const Eos & | eos_i,
|  | bool | irrot,
|  | bool | conf_flat )

Standard constructor.

Parameters

  mp_i | Mapping on which the star will be defined
  nzet_i | Number of domains occupied by the star
  eos_i | Equation of state of the stellar matter
  irrot | should be `true` for an irrotational star, `false` for a corotating one
  conf_flat | should be `true` for a conformally flat metric `false` for a general one

Definition at line 115 of file star_bin.C.

References Lorene::Star::beta, beta_auto, beta_comp, bsn, conf_flat, d_psi, dcon_logn, dcon_phi, dcov_logn, dcov_phi, decouple, flat, Lorene::Star::gamma, Lorene::get_bvect_cart(), gtilde, hij, hij_auto, hij_comp, irrotational, kcar_auto, kcar_comp, lnq_auto, lnq_comp, loggam, logn_auto, logn_comp, Lorene::Map(), Lorene::Star::mp, pot_centri, psi0, psi4, set_der_0x0(), ssjm1_h11, ssjm1_h21, ssjm1_h22, ssjm1_h31, ssjm1_h32, ssjm1_h33, ssjm1_khi, ssjm1_lnq, ssjm1_logn, Lorene::Star::Star(), Lorene::Star::stress_euler, tkij_auto, tkij_comp, Lorene::Star::u_euler, and wit_w.

## Star_bin() [2/3]

Lorene::Star_bin::Star_bin | ( | const Star_bin & | star | ) |

Copy constructor.

Definition at line 210 of file star_bin.C.

References beta_auto, beta_comp, bsn, conf_flat, d_psi, dcon_logn, dcon_phi, dcov_logn, dcov_phi, decouple, flat, gtilde, hij, hij_auto, hij_comp, irrotational, kcar_auto, kcar_comp, lnq_auto, lnq_comp, loggam, logn_auto, logn_comp, pot_centri, psi0, psi4, set_der_0x0(), ssjm1_h11, ssjm1_h21, ssjm1_h22, ssjm1_h31, ssjm1_h32, ssjm1_h33, ssjm1_khi, ssjm1_lnq, ssjm1_logn, Lorene::Star::Star(), Star_bin(), tkij_auto, tkij_comp, and wit_w.

## Star_bin() [3/3]

Lorene::Star_bin::Star_bin | ( | Map & | mp_i,
|  | const Eos & | eos_i,
|  | FILE * | fich )

Constructor from a file (see `sauve(FILE* )`).

Parameters

  mp_i | Mapping on which the star will be defined
  eos_i | Equation of state of the stellar matter
  fich | input file (must have been created by the function `sauve`)

Definition at line 258 of file star_bin.C.

References Lorene::Star::beta, beta_auto, beta_comp, bsn, conf_flat, d_psi, dcon_logn, dcon_phi, dcov_logn, dcov_phi, decouple, flat, Lorene::Star::gam_euler, Lorene::Star::gamma, Lorene::get_bvect_cart(), Lorene::get_mg(), gtilde, hij, hij_auto, hij_comp, irrotational, kcar_auto, kcar_comp, lnq_auto, lnq_comp, loggam, logn_auto, logn_comp, Lorene::Map(), Lorene::Star::mp, pot_centri, psi0, psi4, set_der_0x0(), ssjm1_h11, ssjm1_h21, ssjm1_h22, ssjm1_h31, ssjm1_h32, ssjm1_h33, ssjm1_khi, ssjm1_lnq, ssjm1_logn, Lorene::Star::Star(), Lorene::Star::stress_euler, tkij_auto, tkij_comp, Lorene::Star::u_euler, and wit_w.

## ~Star_bin()

Lorene::Star_bin::~Star_bin | ( |  | ) |

virtual

Destructor.

Definition at line 359 of file star_bin.C.

References del_deriv().

## Member Function Documentation

## del_deriv()

void Lorene::Star_bin::del_deriv | ( |  | ) | const

protected virtual

Deletes all the derived quantities.

Reimplemented from Lorene::Star.

Definition at line 369 of file star_bin.C.

References Lorene::Star::del_deriv(), p_xa_barycenter, and set_der_0x0().

## del_hydro_euler()

void Lorene::Star_bin::del_hydro_euler | ( |  | ) |

protected virtual

Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.

Reimplemented from Lorene::Star.

Definition at line 389 of file star_bin.C.

References del_deriv(), and Lorene::Star::del_hydro_euler().

## equation_of_state()

void Lorene::Star::equation_of_state | ( |  | ) |

inherited

Computes the proper baryon and energy density, as well as pressure from the enthalpy.

Definition at line 462 of file star.C.

References Lorene::Param::add_int(), Lorene::Scalar::allocate_all(), del_deriv(), ener, ent, eos, Lorene::Mg3d::get_grille3d(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), mp, nbar, nzet, press, Lorene::Mtbl::set(), Lorene::Scalar::set_domain(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Scalar::std_spectral_base(), Lorene::Mtbl::t, and Lorene::Grille3d::x.

## equilibrium()

void Lorene::Star_bin::equilibrium | ( | double | ent_c,
|  | int | mermax,
|  | int | mermax_potvit,
|  | int | mermax_poisson,
|  | double | relax_poisson,
|  | double | relax_potvit,
|  | double | thres_adapt,
|  | Tbl & | diff,
|  | double | om )

Computes an equilibrium configuration.

Parameters

  ent_c | [input] Central enthalpy
  mermax | [input] Maximum number of steps
  mermax_poisson | [input] Maximum number of steps in poisson scalar
  relax_poisson | [input] Relaxation factor in poisson scalar
  mermax_potvit | [input] Maximum number of steps in Map_radial::poisson_compact
  relax_potvit | [input] Relaxation factor in Map_radial::poisson_compact
  thres_adapt | [input] Threshold on dH/dr for the adaptation of the mapping
  diff | [output] 1-D `Tbl` for the storage of some error indicators

Definition at line 143 of file star_bin_equilibrium.C.

References Lorene::abs(), Lorene::Param::add_cmp_mod(), Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::Param::add_tenseur_mod(), Lorene::Cmp::annule_hard(), Lorene::Scalar::annule_hard(), Lorene::Star::beta, beta_auto, conf_flat, Lorene::contract(), dcon_logn, dcon_phi, dcov_logn, dcov_phi, Lorene::Scalar::dec_dzpuis(), Lorene::Tensor::dec_dzpuis(), Lorene::Scalar::derive_con(), Lorene::Tensor::derive_con(), Lorene::Scalar::derive_cov(), Lorene::Tensor::derive_cov(), Lorene::Tensor_sym::derive_cov(), Lorene::diffrel(), Lorene::Vector::divergence(), Lorene::Star::ener_euler, Lorene::Star::ent, Lorene::Star::equation_of_state(), Lorene::exp(), Lorene::Scalar::filtre(), flat, Lorene::Connection::get_delta(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), gtilde, hij, hij_auto, Lorene::Map_et::homothetie(), hydro_euler(), Lorene::Tensor::inc_dzpuis(), irrotational, kcar_auto, kcar_comp, lnq_auto, loggam, Lorene::Star::logn, logn_auto, logn_comp, Lorene::max(), Lorene::Star::mp, Lorene::Star::nn, Lorene::norme(), Lorene::Star::nzet, Lorene::phi, Lorene::Scalar::poisson(), Lorene::Tenseur::poisson_vect_oohara(), pot_centri, Lorene::pow(), Lorene::Star::press, psi4, Lorene::Star::ray_eq(), Lorene::Star::ray_eq_pi(), Lorene::Star::ray_pole(), Lorene::Star::s_euler, Lorene::Itbl::set(), Lorene::Tbl::set(), Lorene::Tenseur::set(), Lorene::Tensor::set(), Lorene::Vector::set(), Lorene::Cmp::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tensor::set_etat_zero(), Lorene::Scalar::set_outer_boundary(), Lorene::Tenseur::set_std_base(), Lorene::sqrt(), ssjm1_h11, ssjm1_h21, ssjm1_h22, ssjm1_h31, ssjm1_h32, ssjm1_h33, ssjm1_khi, ssjm1_lnq, ssjm1_logn, Lorene::Scalar::std_spectral_base(), Lorene::Tensor::std_spectral_base(), Lorene::Vector::std_spectral_base(), Lorene::Star::stress_euler, tkij_auto, tkij_comp, Lorene::Star::u_euler, Lorene::Scalar::val_grid_point(), and velocity_potential().

## equilibrium_spher()

void Lorene::Star::equilibrium_spher | ( | double | ent_c,
|  | double | precis = 1.e-14,
|  | const Tbl * | pent_limit = 0x0 )

virtual inherited

Computes a spherical static configuration.

Parameters

  ent_c | [input] central value of the enthalpy
  precis | [input] threshold in the relative difference between the enthalpy fields of two consecutive steps to stop the iterative procedure (default value: 1.e-14)
  ent_limit | [input] : array of enthalpy values to be set at the boundaries between the domains; if set to 0x0 (default), the initial values will be kept.

Definition at line 95 of file star_equil_spher.C.

References Lorene::Map_et::adapt(), Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::diffrel(), Lorene::Map_af::dsdr(), Lorene::Scalar::dsdr(), ener, ener_euler, ent, equation_of_state(), Lorene::exp(), gam_euler, gamma, Lorene::Map_af::get_alpha(), Lorene::Map_et::get_alpha(), Lorene::Map_af::get_beta(), Lorene::Map_et::get_beta(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_af::homothetie(), Lorene::Scalar::integrale(), logn, mass_b(), mass_g(), mp, nn, Lorene::norme(), nzet, Lorene::Map_af::poisson(), press, s_euler, Lorene::Tensor::set(), Lorene::Map_af::set_alpha(), Lorene::Map_af::set_beta(), Lorene::Scalar::set_dzpuis(), Lorene::Cmp::set_etat_qcq(), Lorene::Tensor::set_etat_zero(), Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), u_euler, and Lorene::Scalar::val_grid_point().

## extrinsic_curvature()

void Lorene::Star_bin::extrinsic_curvature | ( | double | omega | ) |

Computes `tkij_auto` and `akcar_auto` from `beta_auto`, `nn` and `Q`.

Parameters

  omega | angular velocity with respect to an asymptotically inertial observer

Definition at line 75 of file star_bin_extr_curv.C.

References Lorene::Tensor::annule_domain(), Lorene::Scalar::annule_hard(), beta_auto, Lorene::contract(), del_deriv(), Lorene::Mg3d::get_nzone(), gtilde, hij_auto, kcar_auto, Lorene::Star::mp, Lorene::Star::nn, Lorene::Vector::set(), Lorene::Valeur::set_base(), Lorene::Scalar::set_spectral_va(), and tkij_auto.

## fait_d_psi()

void Lorene::Star_bin::fait_d_psi | ( |  | ) |

Computes the gradient of the total velocity potential .

Definition at line 645 of file star_bin.C.

References bsn, Lorene::Vector::change_triad(), d_psi, Lorene::Star::ent, Lorene::exp(), flat, Lorene::Star::gam_euler, irrotational, Lorene::Star::mp, Lorene::Star::nzet, psi0, psi4, Lorene::Vector::set(), Lorene::Valeur::set_base(), Lorene::Vector::std_spectral_base(), and Lorene::Cmp::va.

## get_beta()

const Vector & Lorene::Star::get_beta | ( |  | ) | const

inline inherited

Returns the shift vector .

Definition at line 402 of file star.h.

References beta.

## get_beta_auto()

const Vector & Lorene::Star_bin::get_beta_auto | ( |  | ) | const

inline

Returns the part of the shift vector generated principally by the star.

(Spherical components with respect to the mapping of the star)

Definition at line 817 of file star.h.

References beta_auto.

## get_beta_comp()

const Vector & Lorene::Star_bin::get_beta_comp | ( |  | ) | const

inline

Returns the part of the shift vector generated principally by the star.

(Spherical components with respect to the mapping of the star)

Definition at line 823 of file star.h.

References beta_comp.

## get_bsn()

const Vector & Lorene::Star_bin::get_bsn | ( |  | ) | const

inline

Returns the shift vector, divided by N, of the rotating coordinates, .

(Spherical components with respect to the mapping of the star)

Definition at line 798 of file star.h.

References bsn.

## get_d_psi()

const Vector & Lorene::Star_bin::get_d_psi | ( |  | ) | const

inline

Returns the covariant derivative of the velocity potential (Spherical components with respect to the mapping of the star).

Definition at line 781 of file star.h.

References d_psi.

## get_dcon_logn()

const Vector & Lorene::Star_bin::get_dcon_logn | ( |  | ) | const

inline

Returns the contravariant derivative of .

Definition at line 841 of file star.h.

References dcon_logn.

## get_dcon_phi()

const Vector & Lorene::Star_bin::get_dcon_phi | ( |  | ) | const

inline

Returns the contravariant derivative of (logarithm of the conformal factor).

Definition at line 851 of file star.h.

References dcon_phi.

## get_dcov_logn()

const Vector & Lorene::Star_bin::get_dcov_logn | ( |  | ) | const

inline

Returns the covariant derivative of .

Definition at line 837 of file star.h.

References dcov_logn.

## get_dcov_phi()

const Vector & Lorene::Star_bin::get_dcov_phi | ( |  | ) | const

inline

Returns the covariant derivative of (logarithm of the conformal factor).

Definition at line 846 of file star.h.

References dcov_phi.

## get_decouple()

const Scalar Lorene::Star_bin::get_decouple | ( |  | ) | const

inline

Returns the function used to construct `beta_auto` from `beta`.

Definition at line 908 of file star.h.

References decouple.

## get_ener()

const Scalar & Lorene::Star::get_ener | ( |  | ) | const

inline inherited

Returns the proper total energy density.

Definition at line 370 of file star.h.

References ener.

## get_ener_euler()

const Scalar & Lorene::Star::get_ener_euler | ( |  | ) | const

inline inherited

Returns the total energy density with respect to the Eulerian observer.

Definition at line 376 of file star.h.

References ener_euler.

## get_ent()

const Scalar & Lorene::Star::get_ent | ( |  | ) | const

inline inherited

Returns the enthalpy field.

Definition at line 364 of file star.h.

References ent.

## get_eos()

const Eos & Lorene::Star::get_eos | ( |  | ) | const

inline inherited

Returns the equation of state.

Definition at line 361 of file star.h.

References eos.

## get_flat()

const Metric & Lorene::Star_bin::get_flat | ( |  | ) | const

inline

Return the flat metric defined on the mapping (Spherical components with respect to the mapping of the star).

Definition at line 859 of file star.h.

References flat.

## get_gam_euler()

const Scalar & Lorene::Star::get_gam_euler | ( |  | ) | const

inline inherited

Returns the Lorentz factor between the fluid and Eulerian observers.

Definition at line 382 of file star.h.

References gam_euler.

## get_gamma()

const Metric & Lorene::Star::get_gamma | ( |  | ) | const

inline inherited

Returns the 3-metric .

Definition at line 409 of file star.h.

References gamma.

## get_gtilde()

const Metric & Lorene::Star_bin::get_gtilde | ( |  | ) | const

inline

Return the conformal 3-metric .

Definition at line 862 of file star.h.

References gtilde.

## get_hij()

const Sym_tensor & Lorene::Star_bin::get_hij | ( |  | ) | const

inline

Return the total deviation of the inverse conformal metric from the inverse flat metric.

Definition at line 867 of file star.h.

References hij.

## get_hij_auto()

const Sym_tensor & Lorene::Star_bin::get_hij_auto | ( |  | ) | const

inline

Return the deviation of the inverse conformal metric from the inverse flat metric principally generated by the star.

Definition at line 873 of file star.h.

References hij_auto.

## get_hij_comp()

const Sym_tensor & Lorene::Star_bin::get_hij_comp | ( |  | ) | const

inline

Return the deviation of the inverse conformal metric from the inverse flat metric generated principally by the companion star.

Definition at line 879 of file star.h.

References hij_comp.

## get_kcar_auto()

const Scalar & Lorene::Star_bin::get_kcar_auto | ( |  | ) | const

inline

Returns the part of generated by `beta_auto`.

Definition at line 897 of file star.h.

References kcar_auto.

## get_kcar_comp()

const Scalar & Lorene::Star_bin::get_kcar_comp | ( |  | ) | const

inline

Returns the part of generated by `beta_comp`.

Definition at line 902 of file star.h.

References kcar_comp.

## get_lnq()

const Scalar & Lorene::Star::get_lnq | ( |  | ) | const

inline inherited

Definition at line 406 of file star.h.

## get_lnq_auto()

const Scalar & Lorene::Star_bin::get_lnq_auto | ( |  | ) | const

inline

Returns the part of the vector field generated principally by the star.

Definition at line 828 of file star.h.

References lnq_auto.

## get_lnq_comp()

const Scalar & Lorene::Star_bin::get_lnq_comp | ( |  | ) | const

inline

Returns the part of the vector field generated principally by the companion star.

Definition at line 833 of file star.h.

References lnq_comp.

## get_loggam()

const Scalar & Lorene::Star_bin::get_loggam | ( |  | ) | const

inline

Returns the logarithm of the Lorentz factor between the fluid and the co-orbiting observer.

Definition at line 792 of file star.h.

References loggam.

## get_logn()

const Scalar & Lorene::Star::get_logn | ( |  | ) | const

inline inherited

Returns the logarithm of the lapse N.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 396 of file star.h.

References logn.

## get_logn_auto()

const Scalar & Lorene::Star_bin::get_logn_auto | ( |  | ) | const

inline

Returns the part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the star.

Definition at line 806 of file star.h.

References logn_auto.

## get_logn_comp()

const Scalar & Lorene::Star_bin::get_logn_comp | ( |  | ) | const

inline

Returns the part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the companion star.

Definition at line 811 of file star.h.

References logn_comp.

## get_mp()

const Map & Lorene::Star::get_mp | ( |  | ) | const

inline inherited

Returns the mapping.

Definition at line 355 of file star.h.

References Lorene::Map(), and mp.

## get_nbar()

const Scalar & Lorene::Star::get_nbar | ( |  | ) | const

inline inherited

Returns the proper baryon density.

Definition at line 367 of file star.h.

References nbar.

## get_nn()

const Scalar & Lorene::Star::get_nn | ( |  | ) | const

inline inherited

Returns the lapse function N.

Definition at line 399 of file star.h.

References nn.

## get_nzet()

int Lorene::Star::get_nzet | ( |  | ) | const

inline inherited

Returns the number of domains occupied by the star.

Definition at line 358 of file star.h.

References nzet.

## get_pot_centri()

const Scalar & Lorene::Star_bin::get_pot_centri | ( |  | ) | const

inline

Returns the centrifugal potential.

Definition at line 801 of file star.h.

References pot_centri.

## get_press()

const Scalar & Lorene::Star::get_press | ( |  | ) | const

inline inherited

Returns the fluid pressure.

Definition at line 373 of file star.h.

References press.

## get_psi0()

const Scalar & Lorene::Star_bin::get_psi0 | ( |  | ) | const

inline

Returns the non-translational part of the velocity potential.

Definition at line 776 of file star.h.

References psi0.

## get_psi4()

const Scalar & Lorene::Star_bin::get_psi4 | ( |  | ) | const

inline

Return the conformal factor .

Definition at line 854 of file star.h.

References psi4.

## get_s_euler()

const Scalar & Lorene::Star::get_s_euler | ( |  | ) | const

inline inherited

Returns the trace of the stress tensor in the Eulerian frame.

Definition at line 379 of file star.h.

References s_euler.

## get_stress_euler()

const Tensor & Lorene::Star::get_stress_euler | ( |  | ) | const

inline inherited

Returns the spatial part of the stress-energy tensor with respect to the Eulerian observer.

Definition at line 390 of file star.h.

References stress_euler.

## get_tkij_auto()

const Sym_tensor & Lorene::Star_bin::get_tkij_auto | ( |  | ) | const

inline

Returns the part of the extrinsic curvature tensor generated by `beta_auto`.

(Spherical components with respect to the mapping of the star)

Definition at line 886 of file star.h.

References tkij_auto.

## get_tkij_comp()

const Sym_tensor & Lorene::Star_bin::get_tkij_comp | ( |  | ) | const

inline

Returns the part of the extrinsic curvature tensor generated by `beta_comp`.

(Spherical components with respect to the mapping of the star)

Definition at line 892 of file star.h.

References tkij_comp.

## get_u_euler()

const Vector & Lorene::Star::get_u_euler | ( |  | ) | const

inline inherited

Returns the fluid 3-velocity with respect to the Eulerian observer.

Definition at line 385 of file star.h.

References u_euler.

## get_wit_w()

const Vector & Lorene::Star_bin::get_wit_w | ( |  | ) | const

inline

Returns the spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.

(Spherical components with respect to the mapping of the star)

Definition at line 787 of file star.h.

References wit_w.

## helical()

void Lorene::Star_bin::helical | ( | double | omega | ) | const

Test of the helical symmetry.

## hydro_euler()

void Lorene::Star_bin::hydro_euler | ( |  | ) |

virtual

Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame, as well as `wit_w` and `loggam`.

The calculation is performed starting from the quantities `ent`, `ener`, `press` and `bsn`,
which are supposed to be up to date.
From these, the following fields are updated: `gam_euler`, `u_euler`, `ener_euler`, `s_euler`, `stress_euler`,
`wit_w` and `loggam`.

Reimplemented from Lorene::Star.

Definition at line 66 of file star_bin_hydro.C.

References bsn, Lorene::Tensor::change_triad(), Lorene::contract(), d_psi, del_deriv(), Lorene::Star::ener, Lorene::Star::ener_euler, Lorene::Star::ent, Lorene::exp(), Lorene::Star::gam_euler, Lorene::Star::gamma, irrotational, Lorene::log(), loggam, Lorene::Star::mp, Lorene::norme(), Lorene::Star::press, Lorene::Star::s_euler, Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), Lorene::Star::stress_euler, Lorene::Star::u_euler, and wit_w.

## is_conf_flat()

bool Lorene::Star_bin::is_conf_flat | ( |  | ) | const

inline

Definition at line 910 of file star.h.

## is_irrotational()

bool Lorene::Star_bin::is_irrotational | ( |  | ) | const

inline

Returns `true` for an irrotational motion, `false` for a corotating one.

Definition at line 773 of file star.h.

References irrotational.

## kinematics()

void Lorene::Star_bin::kinematics | ( | double | omega,
|  | double | x_axe )

Computes the quantities `bsn` and `pot_centri`.

The calculation is performed starting from the quantities `nn`, `beta`, `Q`,
which are supposed to be up to date.

Parameters

  omega | angular velocity with respect to an asymptotically inertial observer
  x_axe | absolute X coordinate of the rotation axis

Definition at line 75 of file star_bin_kinema.C.

References Lorene::Star::beta, bsn, Lorene::Tensor::change_triad(), Lorene::contract(), del_deriv(), Lorene::Star::gamma, Lorene::log(), Lorene::Star::mp, Lorene::Star::nn, pot_centri, Lorene::sqrt(), Lorene::xa, and Lorene::ya.

## l_surf()

const Itbl & Lorene::Star::l_surf | ( |  | ) | const

virtual inherited

Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent`) vanishes.

Reimplemented in Lorene::Star_rot.

Definition at line 63 of file star_global.C.

References ent, mp, nzet, p_l_surf, and p_xi_surf.

## mass_b()

double Lorene::Star_bin::mass_b | ( |  | ) | const

virtual

Baryon mass.

Implements Lorene::Star.

Definition at line 67 of file star_bin_global.C.

References Lorene::Star::gam_euler, Lorene::Star::gamma, Lorene::Scalar::integrale(), Lorene::Star::nbar, Lorene::Star::p_mass_b, Lorene::sqrt(), and Lorene::Scalar::std_spectral_base().

## mass_g()

double Lorene::Star_bin::mass_g | ( |  | ) | const

virtual

Gravitational mass.

Implements Lorene::Star.

Definition at line 93 of file star_bin_global.C.

References Lorene::Star::ener_euler, Lorene::Star::gamma, Lorene::Scalar::integrale(), Lorene::Star::nn, Lorene::Star::p_mass_g, Lorene::Star::s_euler, Lorene::sqrt(), and Lorene::Scalar::std_spectral_base().

## operator=()

void Lorene::Star_bin::operator= | ( | const Star_bin & | star | ) |

Assignment to another `Star_bin`.

Definition at line 404 of file star_bin.C.

References beta_auto, beta_comp, bsn, conf_flat, d_psi, dcon_logn, dcon_phi, dcov_logn, dcov_phi, decouple, del_deriv(), flat, gtilde, hij, hij_auto, hij_comp, irrotational, kcar_auto, kcar_comp, lnq_auto, lnq_comp, loggam, logn_auto, logn_comp, Lorene::Star::operator=(), pot_centri, psi0, psi4, ssjm1_h11, ssjm1_h21, ssjm1_h22, ssjm1_h31, ssjm1_h32, ssjm1_h33, ssjm1_khi, ssjm1_lnq, ssjm1_logn, Star_bin(), tkij_auto, tkij_comp, and wit_w.

## operator>>()

ostream & Lorene::Star_bin::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >> (virtual function called by the operator <<).

Reimplemented from Lorene::Star.

Definition at line 522 of file star_bin.C.

References Lorene::Star::beta, beta_auto, bsn, d_psi, Lorene::Star::gam_euler, irrotational, kcar_auto, kcar_comp, loggam, logn_auto, logn_comp, Lorene::max(), Lorene::min(), Lorene::Star::mp, Lorene::Star::operator>>(), Lorene::Star::ray_eq(), Lorene::Star::ray_eq_pi(), tkij_auto, tkij_comp, Lorene::Star::u_euler, wit_w, and xa_barycenter().

## ray_eq()

double Lorene::Star::ray_eq | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 108 of file star_global.C.

References Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq, Lorene::phi, and xi_surf().

## ray_eq_3pis2()

double Lorene::Star::ray_eq_3pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 233 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_3pis2, Lorene::phi, ray_eq_pis2(), and xi_surf().

## ray_eq_pi()

double Lorene::Star::ray_eq_pi | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 186 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pi, Lorene::phi, ray_eq(), and xi_surf().

## ray_eq_pis2()

double Lorene::Star::ray_eq_pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 138 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pis2, Lorene::phi, and xi_surf().

## ray_pole()

double Lorene::Star::ray_pole | ( |  | ) | const

inherited

Coordinate radius at [r_unit].

Definition at line 278 of file star_global.C.

References Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_pole, Lorene::phi, and xi_surf().

## relaxation()

void Lorene::Star_bin::relaxation | ( | const Star_bin & | star_prev,
|  | double | relax_ent,
|  | double | relax_met,
|  | int | mer,
|  | int | fmer_met )

Performs a relaxation on `ent`, `logn_auto`, `lnq_auto`, `beta_auto` and `hij_auto`.

Parameters

  star_prev | [input] star at the previous step.
  relax_ent | [input] Relaxation factor for `ent`
  relax_met | [input] Relaxation factor for `logn_auto`, `lnq_auto`, `beta_auto`, only if ``(mer % fmer_met == 0).
  mer | [input] Step number
  fmer_met | [input] Step interval between metric updates

Definition at line 701 of file star_bin.C.

References beta_auto, del_deriv(), Lorene::Star::ent, Lorene::Star::equation_of_state(), hij_auto, lnq_auto, logn_auto, and Star_bin().

## sauve()

void Lorene::Star_bin::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Star.

Definition at line 489 of file star_bin.C.

References beta_auto, conf_flat, Lorene::Star::gam_euler, hij_auto, irrotational, lnq_auto, logn_auto, psi0, Lorene::Star::sauve(), ssjm1_h11, ssjm1_h21, ssjm1_h22, ssjm1_h31, ssjm1_h32, ssjm1_h33, ssjm1_khi, ssjm1_lnq, and ssjm1_logn.

## set_beta()

Vector & Lorene::Star_bin::set_beta | ( |  | ) |

Read/write of .

Definition at line 475 of file star_bin.C.

References Lorene::Star::beta, and del_deriv().

## set_beta_auto()

Vector & Lorene::Star_bin::set_beta_auto | ( |  | ) |

Read/write of .

Definition at line 468 of file star_bin.C.

References beta_auto, and del_deriv().

## set_conf_flat()

void Lorene::Star_bin::set_conf_flat | ( | bool | confflat | ) |

inline

Write if conformally flat.

Definition at line 765 of file star.h.

References conf_flat.

## set_der_0x0()

void Lorene::Star_bin::set_der_0x0 | ( |  | ) | const

protected virtual

Sets to `0x0` all the pointers on derived quantities.

Reimplemented from Lorene::Star.

Definition at line 381 of file star_bin.C.

References p_xa_barycenter, and Lorene::Star::set_der_0x0().

## set_enthalpy()

void Lorene::Star::set_enthalpy | ( | const Scalar & | ent_i | ) |

inherited

Assignment of the enthalpy field.

Definition at line 379 of file star.C.

References del_deriv(), ent, and equation_of_state().

## set_lnq_auto()

void Lorene::Star_bin::set_lnq_auto | ( | const Scalar & | lnq_auto_new | ) |

inline

Assignment of a new lnq_auto.

Definition at line 755 of file star.h.

References lnq_auto.

## set_logn_auto()

void Lorene::Star_bin::set_logn_auto | ( | const Scalar & | logn_auto_new | ) |

inline

Assignment of a new logn_auto.

Definition at line 751 of file star.h.

References logn_auto.

## set_logn_comp()

Scalar & Lorene::Star_bin::set_logn_comp | ( |  | ) |

Read/write of the logarithm of the lapse generated principally by the companion.

Definition at line 461 of file star_bin.C.

References del_deriv(), and logn_comp.

## set_mp()

Map & Lorene::Star::set_mp | ( |  | ) |

inline inherited

Read/write of the mapping.

Definition at line 322 of file star.h.

References Lorene::Map(), and mp.

## set_pot_centri()

Scalar & Lorene::Star_bin::set_pot_centri | ( |  | ) |

Read/write the centrifugal potential.

Definition at line 454 of file star_bin.C.

References del_deriv(), and pot_centri.

## test_K_Hi()

void Lorene::Star_bin::test_K_Hi | ( |  | ) | const

Test if the gauge conditions we impose are well satisfied.

Definition at line 727 of file star_bin.C.

References flat, gtilde, Lorene::Star::mp, and Lorene::norme().

## update_metric() [1/2]

void Lorene::Star_bin::update_metric | ( | const Star_bin & | comp,
|  | const Star_bin & | star_prev,
|  | double | relax,
|  | double | omega )

Same as `update_metric`(const Star_bin& ) but with relaxation.

Parameters

  comp | companion star.
  star_prev | previous value of the star.
  relax | relaxation parameter.
  omega | angular velocity with respect to an asymptotically inertial observer

Definition at line 276 of file star_bin_upmetr.C.

References Lorene::Star::beta, beta_auto, beta_comp, Lorene::Tensor::change_triad(), Lorene::Vector::change_triad(), conf_flat, del_deriv(), Lorene::exp(), extrinsic_curvature(), flat, Lorene::Star::gamma, Lorene::Star::get_mp(), Lorene::Tensor::get_triad(), gtilde, hij, hij_auto, hij_comp, lnq_auto, lnq_comp, Lorene::Star::logn, logn_auto, logn_comp, Lorene::Map(), Lorene::Star::mp, Lorene::Star::nn, psi4, Lorene::Tensor::set(), Star_bin(), and Lorene::Scalar::val_grid_point().

## update_metric() [2/2]

void Lorene::Star_bin::update_metric | ( | const Star_bin & | comp,
|  | double | omega )

Computes metric coefficients from known potentials, when the companion is another star.

The calculation is performed starting from the quantities `logn_auto`, `lnq_auto`, `beta_auto`, `hij_auto`, `comp.logn_auto`, `comp.lnq_auto`, `comp.beta_auto`, `comp.hij_auto` which are supposed to be up to date. From these, the following fields are updated: `logn_comp`, `lnq_comp`, `beta_comp`, `hij_comp`, `nn`, `psi4`, `beta`,

Parameters

  comp | companion star.
  omega | angular velocity with respect to an asymptotically inertial observer

Definition at line 93 of file star_bin_upmetr.C.

References Lorene::Star::beta, beta_auto, beta_comp, Lorene::Tensor::change_triad(), Lorene::Vector::change_triad(), conf_flat, del_deriv(), Lorene::exp(), extrinsic_curvature(), flat, Lorene::Star::gamma, Lorene::Star::get_mp(), Lorene::Tensor::get_triad(), gtilde, hij, hij_auto, hij_comp, lnq_auto, lnq_comp, Lorene::Star::logn, logn_auto, logn_comp, Lorene::Map(), Lorene::Star::mp, Lorene::Star::nn, psi4, Lorene::Tensor::set(), Star_bin(), and Lorene::Scalar::val_grid_point().

## update_metric_der_comp()

void Lorene::Star_bin::update_metric_der_comp | ( | const Star_bin & | comp,
|  | double | omega )

Computes the derivative of metric functions related to the companion star.

Parameters

  omega | angular velocity with respect to an asymptotically inertial observer

Definition at line 101 of file star_bin_upmetr_der.C.

References Lorene::Tensor::annule_domain(), Lorene::Scalar::annule_hard(), beta_comp, Lorene::Vector::change_triad(), Lorene::contract(), dcon_logn, dcon_phi, dcov_logn, dcov_phi, Lorene::Tensor::dec_dzpuis(), del_deriv(), flat, get_flat(), Lorene::Tensor::get_mp(), Lorene::Mg3d::get_nzone(), Lorene::Tensor::get_triad(), gtilde, hij_comp, kcar_comp, lnq_auto, logn_auto, Lorene::Star::mp, Lorene::Star::nn, Lorene::Vector::set(), Lorene::Valeur::set_base(), Lorene::Scalar::set_spectral_va(), Star_bin(), tkij_auto, and tkij_comp.

## velocity_potential()

double Lorene::Star_bin::velocity_potential | ( | int | mermax,
|  | double | precis,
|  | double | relax )

Computes the non-translational part of the velocity scalar potential by solving the continuity equation.

Parameters

  mermax | [input] Maximum number of steps in the iteration
  precis | [input] Required precision: the iteration will be stopped when the relative difference on between two successive steps is lower than `precis`.
  relax | [input] Relaxation factor.

Returns
  Relative error of the resolution obtained by comparing the operator acting on the solution with the source.

Definition at line 76 of file star_bin_vel_pot.C.

References Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Scalar::annule(), bsn, Lorene::Vector::change_triad(), Lorene::contract(), d_psi, Lorene::Scalar::derive_con(), Lorene::Scalar::derive_cov(), Lorene::diffrel(), Lorene::Tensor::down(), Lorene::Star::ent, Lorene::Star::eos, Lorene::exp(), flat, Lorene::Star::gam_euler, Lorene::Tensor::get_triad(), hij, Lorene::Tensor::inc_dzpuis(), Lorene::Star::mp, Lorene::norme(), Lorene::Star::nzet, psi0, psi4, Lorene::Tenseur::set(), Lorene::Vector::set(), Lorene::Scalar::set_domain(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tensor::set_etat_qcq(), Lorene::Scalar::set_spectral_va(), Lorene::Tensor::set_triad(), Lorene::Scalar::std_spectral_base(), Lorene::Vector::std_spectral_base(), Lorene::Cmp::va, Lorene::Valeur::ylm(), and Lorene::Valeur::ylm_i().

## xa_barycenter()

double Lorene::Star_bin::xa_barycenter | ( |  | ) | const

virtual

Absolute coordinate X of the barycenter of the baryon density,.

Definition at line 118 of file star_bin_global.C.

References Lorene::Tensor::annule_domain(), Lorene::Star::gam_euler, Lorene::Star::gamma, Lorene::Scalar::integrale(), mass_b(), Lorene::Star::mp, Lorene::Star::nbar, p_xa_barycenter, Lorene::sqrt(), and Lorene::Scalar::std_spectral_base().

## xi_surf()

const Tbl & Lorene::Star::xi_surf | ( |  | ) | const

inherited

Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent`) vanishes.

Definition at line 89 of file star_global.C.

References l_surf(), p_l_surf, and p_xi_surf.

## Friends And Related Symbol Documentation

## Binary

friend class Binary

friend

Definition at line 1073 of file star.h.

## Member Data Documentation

## beta

Vector Lorene::Star::beta

protected inherited

Shift vector.

Definition at line 228 of file star.h.

## beta_auto

Vector Lorene::Star_bin::beta_auto

protected

Part of the shift vector generated principally by the star (Spherical components with respect to the mapping of the star).

Definition at line 570 of file star.h.

## beta_comp

Vector Lorene::Star_bin::beta_comp

protected

Part of the shift vector generated principally by the star (Spherical components with respect to the mapping of the star).

Definition at line 575 of file star.h.

## bsn

Vector Lorene::Star_bin::bsn

protected

3-vector shift, divided by N, of the rotating coordinates, .

(Spherical components with respect to the mapping of the star)

Definition at line 518 of file star.h.

## conf_flat

bool Lorene::Star_bin::conf_flat

protected

`true` if the 3-metric is conformally flat, `false` for a more general metric.

Definition at line 681 of file star.h.

## d_psi

Vector Lorene::Star_bin::d_psi

protected

Gradient of (in the irrotational case) (Spherical components with respect to the mapping of the star).

Definition at line 501 of file star.h.

## dcon_logn

Vector Lorene::Star_bin::dcon_logn

protected

Contravariant derivative of the total logarithm of the lapse.

Definition at line 538 of file star.h.

## dcon_phi

Vector Lorene::Star_bin::dcon_phi

protected

Contravariant derivative of the logarithm of the conformal factor.

Definition at line 557 of file star.h.

## dcov_logn

Vector Lorene::Star_bin::dcov_logn

protected

Covariant derivative of the total logarithm of the lapse.

Definition at line 535 of file star.h.

## dcov_phi

Vector Lorene::Star_bin::dcov_phi

protected

Covariant derivative of the logarithm of the conformal factor.

Definition at line 555 of file star.h.

## decouple

Scalar Lorene::Star_bin::decouple

protected

Function used to construct the part generated by the star from the total .

Mainly this `Scalar` is 1 around the star and 0 around the companion and the sum of `decouple` for the star and his companion is 1 everywhere.

Definition at line 676 of file star.h.

## ener

Scalar Lorene::Star::ener

protected inherited

Total energy density in the fluid frame.

Definition at line 193 of file star.h.

## ener_euler

Scalar Lorene::Star::ener_euler

protected inherited

Total energy density in the Eulerian frame.

Definition at line 198 of file star.h.

## ent

Scalar Lorene::Star::ent

protected inherited

Log-enthalpy.

Definition at line 190 of file star.h.

## eos

const Eos& Lorene::Star::eos

protected inherited

Equation of state of the stellar matter.

Definition at line 185 of file star.h.

## flat

Metric_flat Lorene::Star_bin::flat

protected

Flat metric defined on the mapping (Spherical components with respect to the mapping of the star) .

Definition at line 562 of file star.h.

## gam_euler

Scalar Lorene::Star::gam_euler

protected inherited

Lorentz factor between the fluid and Eulerian observers.

Definition at line 204 of file star.h.

## gamma

Metric Lorene::Star::gamma

protected inherited

3-metric

Definition at line 235 of file star.h.

## gtilde

Metric Lorene::Star_bin::gtilde

protected

Conformal metric .

Definition at line 565 of file star.h.

## hij

Sym_tensor Lorene::Star_bin::hij

protected

Total deviation of the inverse conformal metric from the inverse flat metric.

Definition at line 581 of file star.h.

## hij_auto

Sym_tensor Lorene::Star_bin::hij_auto

protected

Deviation of the inverse conformal metric from the inverse flat metric generated principally by the star.

Definition at line 588 of file star.h.

## hij_comp

Sym_tensor Lorene::Star_bin::hij_comp

protected

Deviation of the inverse conformal metric from the inverse flat metric generated principally by the companion star.

Definition at line 594 of file star.h.

## irrotational

bool Lorene::Star_bin::irrotational

protected

`true` for an irrotational star, `false` for a corotating one

Definition at line 491 of file star.h.

## kcar_auto

Scalar Lorene::Star_bin::kcar_auto

protected

Part of the scalar generated by `beta_auto`, i.e.

Definition at line 612 of file star.h.

## kcar_comp

Scalar Lorene::Star_bin::kcar_comp

protected

Part of the scalar generated by `beta_auto` and `beta_comp`, i.e.

Definition at line 618 of file star.h.

## lnq

Scalar Lorene::Star::lnq

protected inherited

Definition at line 232 of file star.h.

## lnq_auto

Scalar Lorene::Star_bin::lnq_auto

protected

Scalar field generated principally by the star.

Definition at line 543 of file star.h.

## lnq_comp

Scalar Lorene::Star_bin::lnq_comp

protected

Scalar field generated principally by the companion star.

Definition at line 548 of file star.h.

## loggam

Scalar Lorene::Star_bin::loggam

protected

Logarithm of the Lorentz factor between the fluid and the co-orbiting observer.

Definition at line 512 of file star.h.

## logn

Scalar Lorene::Star::logn

protected inherited

Logarithm of the lapse N .

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 222 of file star.h.

## logn_auto

Scalar Lorene::Star_bin::logn_auto

protected

Part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the star.

Definition at line 527 of file star.h.

## logn_comp

Scalar Lorene::Star_bin::logn_comp

protected

Part of the lapse logarithm (gravitational potential at the Newtonian limit) generated principally by the companion star.

Definition at line 532 of file star.h.

## mp

Map& Lorene::Star::mp

protected inherited

Mapping associated with the star.

Definition at line 180 of file star.h.

## nbar

Scalar Lorene::Star::nbar

protected inherited

Baryon density in the fluid frame.

Definition at line 192 of file star.h.

## nn

Scalar Lorene::Star::nn

protected inherited

Lapse function N .

Definition at line 225 of file star.h.

## nzet

int Lorene::Star::nzet

protected inherited

Number of domains of `*mp` occupied by the star.

Definition at line 183 of file star.h.

## p_l_surf

Itbl* Lorene::Star::p_l_surf

mutable protected inherited

Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

Definition at line 260 of file star.h.

## p_mass_b

double* Lorene::Star::p_mass_b

mutable protected inherited

Baryon mass.

Definition at line 268 of file star.h.

## p_mass_g

double* Lorene::Star::p_mass_g

mutable protected inherited

Gravitational mass.

Definition at line 269 of file star.h.

## p_ray_eq

double* Lorene::Star::p_ray_eq

mutable protected inherited

Coordinate radius at , .

Definition at line 242 of file star.h.

## p_ray_eq_3pis2

double* Lorene::Star::p_ray_eq_3pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 251 of file star.h.

## p_ray_eq_pi

double* Lorene::Star::p_ray_eq_pi

mutable protected inherited

Coordinate radius at , .

Definition at line 248 of file star.h.

## p_ray_eq_pis2

double* Lorene::Star::p_ray_eq_pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 245 of file star.h.

## p_ray_pole

double* Lorene::Star::p_ray_pole

mutable protected inherited

Coordinate radius at .

Definition at line 254 of file star.h.

## p_xa_barycenter

double* Lorene::Star_bin::p_xa_barycenter

mutable protected

Absolute coordinate X of the barycenter of the baryon density.

Definition at line 687 of file star.h.

## p_xi_surf

Tbl* Lorene::Star::p_xi_surf

mutable protected inherited

Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

Definition at line 266 of file star.h.

## pot_centri

Scalar Lorene::Star_bin::pot_centri

protected

Centrifugal potential.

Definition at line 521 of file star.h.

## press

Scalar Lorene::Star::press

protected inherited

Fluid pressure.

Definition at line 194 of file star.h.

## psi0

Scalar Lorene::Star_bin::psi0

protected

Scalar potential of the non-translational part of fluid 4-velocity (in the irrotational case).

Definition at line 496 of file star.h.

## psi4

Scalar Lorene::Star_bin::psi4

protected

Conformal factor .

Definition at line 552 of file star.h.

## s_euler

Scalar Lorene::Star::s_euler

protected inherited

Trace of the stress scalar in the Eulerian frame.

Definition at line 201 of file star.h.

## ssjm1_h11

Scalar Lorene::Star_bin::ssjm1_h11

protected

Effective source at the previous step for the resolution of the Poisson equation for `h00_auto`.

Definition at line 641 of file star.h.

## ssjm1_h21

Scalar Lorene::Star_bin::ssjm1_h21

protected

Effective source at the previous step for the resolution of the Poisson equation for `h10_auto`.

Definition at line 646 of file star.h.

## ssjm1_h22

Scalar Lorene::Star_bin::ssjm1_h22

protected

Effective source at the previous step for the resolution of the Poisson equation for `h11_auto`.

Definition at line 656 of file star.h.

## ssjm1_h31

Scalar Lorene::Star_bin::ssjm1_h31

protected

Effective source at the previous step for the resolution of the Poisson equation for `h20_auto`.

Definition at line 651 of file star.h.

## ssjm1_h32

Scalar Lorene::Star_bin::ssjm1_h32

protected

Effective source at the previous step for the resolution of the Poisson equation for `h21_auto`.

Definition at line 661 of file star.h.

## ssjm1_h33

Scalar Lorene::Star_bin::ssjm1_h33

protected

Effective source at the previous step for the resolution of the Poisson equation for `h22_auto`.

Definition at line 666 of file star.h.

## ssjm1_khi

Scalar Lorene::Star_bin::ssjm1_khi

protected

Effective source at the previous step for the resolution of the Poisson equation for `khi`.

(second scalar equation for the resolution of the vectorial poisson equation for the shift)

Definition at line 634 of file star.h.

## ssjm1_lnq

Scalar Lorene::Star_bin::ssjm1_lnq

protected

Effective source at the previous step for the resolution of the Poisson equation for `lnq_auto`.

Definition at line 628 of file star.h.

## ssjm1_logn

Scalar Lorene::Star_bin::ssjm1_logn

protected

Effective source at the previous step for the resolution of the Poisson equation for `logn_auto`.

Definition at line 623 of file star.h.

## ssjm1_wbeta

Vector Lorene::Star_bin::ssjm1_wbeta

protected

Definition at line 636 of file star.h.

## stress_euler

Sym_tensor Lorene::Star::stress_euler

protected inherited

Spatial part of the stress-energy tensor with respect to the Eulerian observer.

Definition at line 212 of file star.h.

## tkij_auto

Sym_tensor Lorene::Star_bin::tkij_auto

protected

Part of the extrinsic curvature tensor generated by `beta_auto`.

(Spherical components with respect to the mapping of the star)

Definition at line 600 of file star.h.

## tkij_comp

Sym_tensor Lorene::Star_bin::tkij_comp

protected

Part of the extrinsic curvature tensor generated by `beta_comp`.

(Spherical components with respect to the mapping of the star)

Definition at line 606 of file star.h.

## u_euler

Vector Lorene::Star::u_euler

protected inherited

Fluid 3-velocity with respect to the Eulerian observer.

Definition at line 207 of file star.h.

## wit_w

Vector Lorene::Star_bin::wit_w

protected

Spatial projection of the fluid 3-velocity with respect to
the co-orbiting observer.

(Spherical components with respect to the mapping of the star)

Definition at line 507 of file star.h.

The documentation for this class was generated from the following files:

- star.h
- star_bin.C
- star_bin_equilibrium.C
- star_bin_extr_curv.C
- star_bin_global.C
- star_bin_hydro.C
- star_bin_kinema.C
- star_bin_upmetr.C
- star_bin_upmetr_der.C
- star_bin_vel_pot.C